import socket                                                                                                                                                                                             
from infosec import Infosec                                                                                                                                                                               

class Peer(object):
    def __init__(self, server, peer_entry):
        self.server = server
        self.name = peer_entry["name"]
        self.address = peer_entry["address"]
        self.local_secret = peer_entry["local_secret"]
        self.remote_secret = peer_entry["remote_secret"]
        self.port = peer_entry["port"]
        self.socket = socket.socket(family=socket.AF_INET, type=socket.SOCK_DGRAM)
        self.infosec = Infosec(server)                                 

    def send(self, client, msg, timestamp=None):
        if(timestamp == None):
            full_message = str.encode(":%s %s" % (client.nickname, msg))                                        
        else:
            full_message = str.encode(msg)                                        
        self.server.print_debug("sending formatted_msg: %s" % full_message)
        self.socket.sendto(self.infosec.pack(self, full_message, timestamp), (self.address, self.port))   
